<html><head><title>Form-To-Mail</title><head><body style='margin:10px 30px 10px 10px;'><a name='Form-To-Mail'></a><h2>Form-To-Mail</h2><a name='Introduction'></a><h3>Introduction  <span style='font-size:small'><a href='#Introduction'>#</a></span></h3><p>The Form-To-Mail package is designed to work somewhat like formmail.pl - the user enters information into an HTML form on a page, and upon submitting the page the data is collected and emailed to an address of the administrator's choosing.  <span style='font-size:small'></span><blockquote></blockquote></p>
<p>Form-to-Mail (FTM) is designed with reuse, and hopefully some security, in mind. Email addresses such as sender and recipient are configured by the administrator, stored in the database, and cannnot be overridden by form variables, which limits abuse of the form by third parties.  <span style='font-size:small'></span><blockquote></blockquote></p>
<p>FTM is designed to be included on other pages in the site, and provides a facility for adding custom form elements to the form, using a .tcl file that can be as simple or complex as the developer requires. The package uses a single instance to generate the included HTML form, and to process the submitted form.  <span style='font-size:small'></span><blockquote></blockquote></p>

<a name='Getting'></a><h3>Getting Started  <span style='font-size:small'><a href='#Getting'>#</a></span></h3><p>Form-to-Mail is made up of two pages: form and form-proc. To add a mail form to your site, first mount an instance of Form-To-Mail under your site. The name of the instance doesn't really matter, but there should be only one instance and it would be good to name it something generic but that does not give away its purpose (i.e., naming it "Form-to-Mail" is likely to invite malcontents to try and abuse it). I like to use 'ftm'.  <span style='font-size:small'></span><blockquote></blockquote></p>
<p>Visit /yoursite/<ftm-instance>/admin. (Replace <ftm-instance> with whatever you named your Form-to-Mail instance.  <span style='font-size:small'></span><blockquote><p><div><img src="forms.jpg" alt="" width="571" height="177" border="1" align="bottom" /><br>Fig 1: The Form-to-Mail Admin page</div><br></p>
</blockquote></p>
<p>Add a new form, entering the information as requested:  <span style='font-size:small'></span><blockquote><p><b>Form Name:</b> a descriptive name you can remember. You'll use it when adding the form to your pages. <br></p>
<p><b>Subject Prefix:</b> a prefix, often of a form like "[name of form]", but can be whatever you want. The user will not see this, but it can help the recipient recognize and filter incoming mail from the form. <br></p>
<p><b>Subject Default:</b> this will be the default subject, and will appear in the subject form field when the user creates a new form. The user can replace this with whatever they want. <br></p>
<p><b>Show Subject: Yes/No</b> - Should the form show a subject field, or just use the default subject?<br></p>
<p><b>Show Comments: Yes/No</b> - Should the form show the comments textarea?<br></p>
<p><b>Recipient:</b> valid email address where the email from the form will be directed. <br></p>
<p><b>Sender:</b> email address with at least a valid domain which will be used as the "from" address in the email. <br></p>
<p><b>Confirmation:</b> Enter the Confirmation or Thank You message you would like to display to the user when the form is successfully submitted.<br></p>
<p><div><img src="addForm.jpg" alt="" width="458" height="523" border="1" align="bottom" /><br>Fig 2: Adding a form</div><br></p>
</blockquote></p>

<a name='Usage'></a><h3>Usage  <span style='font-size:small'><a href='#Usage'>#</a></span></h3><p>On the page or template where you want the form to appear, include it like this:  <span style='font-size:small'></span><blockquote></blockquote></p>
<p><include src="/packages/form-to-mail/www/form" form_name="name of the form" extra_form_file="/path/to/file">  <span style='font-size:small'></span><blockquote></blockquote></p>
<p>src : typical include src. Should always be "/packages/form-to-mail/www/form".  <span style='font-size:small'></span><blockquote></blockquote></p>
<p>form_name : This is the descriptive name you gave the form when creating it. This tells the form-to-mail package which default values to pull fromt he database, and later, which sender and recipient to use.  <span style='font-size:small'></span><blockquote></blockquote></p>
<p>extra_form_file : Optional, this is a .tcl file containing at least a call to ad_form -extend, as documented below.  <span style='font-size:small'></span><blockquote><p><div><img src="include.jpg" alt="" width="413" height="78" border="1" align="bottom" /><br>Fig 3: Including the form</div><br></p>
</blockquote></p>

<a name='Extra_form_file'></a><h3>Extra_form_file  <span style='font-size:small'><a href='#Extra_form_file'>#</a></span></h3><p>Form-to-Mail is designed to be extensible. The forms you create in the admin area can be used as is - subject and body (actually title and comments) fields will be generated for you. However, most developers will want to collect a variety of information from the form. FTM provides for this by taking a .tcl file as a parameter to the <include> tag and sourcing it when generating the form. <span style='font-size:small'></span><blockquote></blockquote></p>
<p>Create a .tcl file in your site somewhere. I usually name it after the form I'm extending, i.e. form_name_extra_form.tcl. In the file, you need at least one call to <code>ad_form -extend -name mail_form</code>, like this:  <span style='font-size:small'></span><blockquote><p><pre>ad_form -extend -name mail_form -form {
    { ftmx.field1:text ... }
    { ftmx.field2:text(select) ... }
}</pre><br></p>
<p><div><img src="extra_form.jpg" alt="" width="324" height="168" border="1" align="bottom" /><br>Fig 4: The extra_form_file</div><br></p>
</blockquote></p>
<p>The form name, "mail_form", is the name of the form generated by the package and should not be changed.  <span style='font-size:small'></span><blockquote></blockquote></p>
<p>In the call to ad_form, your form elements should be named with "ftmx." as a prefix. This adds the form element to an array passed to the form processor, and makes sure that it gets added to the outgoing email.  <span style='font-size:small'></span><blockquote></blockquote></p>
<p>You can use whatever techniques you want to generate your form elements. One popular technique might be to fetch a list of values from the database to create the options for a select input (drop-down list element). Another might be grabbing the url of the current page to pass as a hidden field and thereby sent with the email.  <span style='font-size:small'></span><blockquote><p><div><img src="moreInfoForm.jpg" alt="" width="458" height="234" border="1" align="bottom" /><br>Fig 5: The rendered form</div><br></p>
<p><div><img src="thankYou.jpg" alt="" width="519" height="169" border="1" align="bottom" /><br>Fig 6: After submitting</div><br></p>
<p><div><img src="email.jpg" alt="" width="313" height="137" border="1" align="bottom" /><br>Fig 7: The email</div><br></p>
</blockquote></p>

<a name='Acknowledgements'></a><h3>Acknowledgements <span style='font-size:small'><a href='#Acknowledgements'>#</a></span></h3><p>I would be completely remiss if I did not thank the denizens of #openacs - especially daveb, jadeforrest, jim, jaufrec, michaels, talli, and til - for their help, encouragement, and patience with a complete n00b.  <span style='font-size:small'></span><blockquote></blockquote></p>

<p style='font-size:small'>Last Modified: Wednesday, July 30, 2003 11:54:08 AM</p></body></html>